//+------------------------------------------------------------------+
//|                                                     ScalpBot.mq4 |
//|                                                           doshur |
//|                                                   www.doshur.com |
//+------------------------------------------------------------------+
#property copyright "doshur"
#property link      "www.doshur.com"

//---- input parameters

extern double Scalp = 4;
extern double StopLoss = 15;

//----

int init()
  {
   return(0);
  }

int deinit()
  {
   return(0);
  }

int start()
  {
//---- Indicators

   double TrendRanger_0 = iCustom(NULL,5,"RangerEA",13,2,13,3,0,0);
   double TrendRanger_1 = iCustom(NULL,5,"RangerEA",13,2,13,3,0,1);

   double TrendStoch_0 = iStochastic(NULL,5,5,3,3,MODE_LWMA,0,MODE_MAIN,1);
   double TrendStoch_1 = iStochastic(NULL,5,5,3,3,MODE_LWMA,0,MODE_SIGNAL,1);

   double EntryStoch_0 = iStochastic(NULL,1,5,3,3,MODE_EMA,0,MODE_MAIN,0);
   double EntryStoch_1 = iStochastic(NULL,1,5,3,3,MODE_EMA,0,MODE_SIGNAL,0);

//---- Execute

   //---- Buy
   if(TrendRanger_0 > 0 && TrendRanger_0 > TrendRanger_1 &&
   TrendStoch_0 > TrendStoch_1 &&
   EntryStoch_0 > EntryStoch_1 && EntryStoch_0 < 20 &&
   Check_OpenTrades(1) < 1)
   {
      OrderSend(Symbol(),OP_BUY,Check_Lots(),Ask,3,Ask - StopLoss * Point,0,"doshur",305442,0,Blue);
   }

   //---- Sell
   if(TrendRanger_0 < 0 && TrendRanger_0 < TrendRanger_1 &&
   TrendStoch_0 < TrendStoch_1 &&
   EntryStoch_0 < EntryStoch_1 && EntryStoch_0 > 80 &&
   Check_OpenTrades(2) < 1)
   {
      OrderSend(Symbol(),OP_SELL,Check_Lots(),Bid,3,Bid + StopLoss * Point,0,"doshur",305442,0,Red);
   }

   int cnt;

   if(EntryStoch_0 < EntryStoch_1)
   {
      for(cnt = OrdersTotal() - 1; cnt >= 0; cnt--)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if(OrderType() == OP_BUY && OrderSymbol() == Symbol())
         if((Bid - OrderOpenPrice()) >= (Scalp * Point))
         {
            OrderClose(OrderTicket(),OrderLots(),Bid,3,Black);
         }
      }
   }

   if(EntryStoch_0 > EntryStoch_1)
   {
      for(cnt = OrdersTotal() - 1; cnt >= 0; cnt--)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if(OrderType() == OP_SELL && OrderSymbol() == Symbol())
         if((OrderOpenPrice() - Ask) >= (Scalp * Point))
         {
            OrderClose(OrderTicket(),OrderLots(),Ask,3,Black);
         }
      }
   }

//----

   return(0);
  }
//+------------------------------------------------------------------+

//---- Check Open Trades
int Check_OpenTrades(int bs)
{
   int buys = 0, sells = 0;

   for(int c_OT = 0; c_OT < OrdersTotal(); c_OT++)
   {
      OrderSelect(c_OT, SELECT_BY_POS, MODE_TRADES);

      if(OrderType() == OP_BUY && OrderSymbol() == Symbol()) buys++;
      if(OrderType() == OP_SELL && OrderSymbol() == Symbol()) sells++;
   }

   if(bs == 1) return(buys);
   if(bs == 2) return(sells);
}

//---- Optimize Lots
double Check_Lots()
{
   double rLots;

   rLots = NormalizeDouble(AccountBalance() / 100 / 100 * 1.8,1);

   if(rLots > 5) rLots = 5;
   if(rLots < 0.1) rLots = 0.1;

   return(rLots);
}